#!/bin/sh
#SRC=$USERDATAPATH

DEST=/mnt/mtdblock
DEST2=/mnt/mtdblock/data
DESTAPP=/mnt/mtdblock/app
DESTAPPLIB=/mnt/mtdblock/lib/app
DESTSERVICE=/mnt/mtdblock/service
LIB=/mnt/mtdblock/lib
DRIVER=/mnt/mtdblock/drivers
LOGDIR=/mnt/mtdblock/logdir
LOGSUFFIX=.log
LOGLEVEL=EIWD
PUSHLOGLEVEL=EIW

#LOGTEST="yes"
LicdmService=licdm
HubService=hub
OptionsTool=initoptionstool
DevService=devs
BiometricService=biometric
MginitService=mginit
PushService=pushcomm
PullService=pullcomm
StandaloneService=standalonecomm
WebService=webcomm
MainApp=main

udevtrigger
chmod -R 777 $DESTAPP

ifconfig eth0 192.168.1.201 up

if [ ! -d /var/tmp ]; then
	mkdir /var/tmp
fi

if [ -f $DEST/test.sh ]; then         
	cd $DEST && chmod u+x $DEST/test.sh && $DEST/test.sh
	rm test.sh
fi

if [ "${LOGTEST}" = "yes" ]; then
	echo "Create Log"
	if [ ! -d ${LOGDIR} ]; then
		mkdir ${LOGDIR}
	fi
fi

rm -rf /var/nfftmp/*
rm -rf /var/tmp/*
rm -rf /var/run/ppp* 
rm -rf /mnt/mtdblock/auto1.sh

pgrep ${LicdmService} > /dev/nul
if [ "$?" = 0 ]; then
	if [ -f $DEST/kill.sh ]; then
		count=0
		while [ ${count} -le 5 ]
		do
			cd $DEST && chmod u+x $DEST/kill.sh && $DEST/kill.sh
			count=$((${count} + 1))
		done
	fi
fi

if [ ! -d /var/lock ]; then
	mkdir /var/lock
fi

if [ ! -d /var/nfftmp ]; then
	mkdir /var/nfftmp
fi

if [ ! -d /usr/lib ]; then
	mkdir /usr/lib
fi

if [ ! -d $DEST2/capture/pass ]; then
	mkdir -p $DEST2/capture/pass
fi

if [ ! -d $DEST2/capture/bad ]; then
	mkdir -p $DEST2/capture/bad
fi

if [ ! -d $DEST2/photo ]; then
	mkdir -p $DEST2/photo
fi

sync

if [ -d $DEST/wav ]; then
	mkdir -p /mnt/ramdisk/wav && cp $DEST/wav/?[^_]*.wav /mnt/ramdisk/wav/ -rf && sync
fi

if [ ! -f /usr/sbin/pppd ]; then
	cp /mnt/mtdblock/drivers/gprs/* /usr/sbin/. -rf && sync
fi

#还原数据
if [ -f $DEST/data/restore/RestoreOK ]; then 
	tar -zxvf $DEST/data/restore/restore.tgz -C $DEST/data/ && sync && rm $DEST/data/restore/restore.tgz $DEST/data/restore/RestoreOK -rf && sync
	echo 3 > /proc/sys/vm/drop_caches
fi

#U盘升级二进制文件
if [ -f $DEST/data/update.tgz ]; then 
	tar -zxvf $DEST/data/update.tgz -C / && sync && rm $DEST/data/update.tgz && sync
	echo 3 > /proc/sys/vm/drop_caches
fi

if [ -f $DEST/mtdblock.tgz ]; then 
	tar -zxvf $DEST/mtdblock.tgz -C $DEST/ && sync && rm $DEST/mtdblock.tgz && sync
	echo 3 > /proc/sys/vm/drop_caches
fi

if [ -f $DEST/language.tgz ]; then 
	tar -zxvf $DEST/language.tgz -C $DEST/ && sync && rm $DEST/language.tgz && sync
fi

if [ -f $DEST/languagesig.tgz ]; then 
	tar -xvf $DEST/languagesig.tgz -C $DEST/ && sync && rm $DEST/languagesig.tgz && sync
fi

if [ -d $DEST/app/mginit/language/lang ]; then
	rm -rf $DEST/app/mginit/language/lang && sync
fi

if [ -f $DEST/lib/minires.tgz ]; then
	tar -xzf $DEST/lib/minires.tgz -C /usr/local/lib && sync && rm $DEST/lib/minires.tgz -f &&  sync
fi

if [ -f /mnt/mtdblock/profile ]; then
	mv /mnt/mtdblock/profile /etc/profile
	mv /mnt/mtdblock/rcS /etc/init.d/rcS
	sync
	sleep 3
	sync
	#exit
	reboot
fi

if [ -f $DEST/drivers/gpio_drv.ko ]; then
	insmod $DEST/drivers/gpio_drv.ko
fi

if [ -f $DRIVER/zkboard.ko ]; then 
	insmod $DRIVER/zkboard.ko
fi

if [ -f /mnt/mtdblock/drivers/wiegandout.ko ]; then
	insmod $DEST/drivers/wiegandout.ko
fi

if [ -f /mnt/mtdblock/drivers/wiegandin.ko ]; then
	insmod $DEST/drivers/wiegandin.ko
fi

#battery
if [ -f $DEST/drivers/ak4182.ko ]; then
	insmod $DEST/drivers/ak4182.ko
fi
#battery end

if [ -f $DEST/drivers/wifi/rtnetsta.ko ]; then
	insmod $DEST/drivers/wifi/rtutilsta.ko
	insmod $DEST/drivers/wifi/rtsta.ko
	insmod $DEST/drivers/wifi/rtnetsta.ko
fi

if [ ! -f /dev/crypt_dev ]; then
	mknod /dev/crypt_dev c 218 0
fi

if [ ! -c /dev/ppp ]; then 
	mknod /dev/ppp c 108 0 
fi

if [ ! -c /dev/zkboard ]; then
	mknod /dev/zkboard c 217 0
fi

ALGOLIB=$DEST/lib/libzkfp.so.3.5.1

if [ ! -f /etc/MiniGUI.cfg ]; then
	ln -snf $DEST/app/mginit/MiniGUI.cfg /etc/
fi

if [  -d /lib/device ]; then       
        rm -rf /lib/device         
fi

if [ ! -f /lib/device ]; then
	ln -snf /mnt/mtdblock/lib/device/zkdev /lib/device
fi

#for secugen PIV
if [ -f $LIB/libsecugen.so ]; then
	ln -snf $LIB/libsecugen.so /lib/
	ln -snf $LIB/libsgfdu04.so /lib/
	ln -snf $LIB/libusb.so /lib/
	ln -snf /lib/libusb.so /lib/libusb-0.1.so.4
fi

if [ ! -f /usr/lib/libiale_custom.so ]; then
	ln -snf $LIB/libcustom_procs.so  /usr/lib/libiale_custom.so
fi
if [ ! -f $LIB/libsqlite3.so.0 ]; then
	ln -snf $LIB/libsqlite3.so  $LIB/libsqlite3.so.0
fi
if [ ! -f $LIB/libpng12.so.0 ]; then
	ln -snf $LIB/libpng12.so.0.37.0  $LIB/libpng12.so.0
fi
if [ ! -f $LIB/libttf.so.2 ]; then
	ln -snf $LIB/libttf.so  $LIB/libttf.so.2
fi
if [ ! -f $LIB/libz.so.1 ]; then
	ln -snf $LIB/libz.so.1.2.2  $LIB/libz.so.1
fi
if [ ! -f $LIB/libjpeg.so.7 ]; then
	ln -snf $LIB/libjpeg.so.7.0.0  $LIB/libjpeg.so.7
fi
if [ ! -f $LIB/libminigui_procs-3.0.so.12 ]; then
	ln -snf $LIB/libminigui_procs.so.3.0.12  $LIB/libminigui_procs-3.0.so.12
fi
if [ ! -f $LIB/libminigui_procs.so.3 ]; then
	ln -snf $LIB/libminigui_procs.so.3.0.12  $LIB/libminigui_procs.so.3
fi
if [ ! -f $LIB/libsoftkeywin.so.0 ]; then
	ln -snf $LIB/libsoftkeywin.so  $LIB/libsoftkeywin.so.0
fi
if [ ! -f $LIB/libts-1.0.so.0 ]; then
	ln -snf $LIB/libts-0.0.so.0.1.1 $LIB/libts-1.0.so.0
fi
if [ ! -f $LIB/libfreetype.so.6 ]; then
	ln -snf $LIB/libfreetype.so.6.3.20 $LIB/libfreetype.so.6
fi
if [ ! -f $LIB/libxml2.so.2 ]; then
	ln -snf $LIB/libxml2.so $LIB/libxml2.so.2
fi
if [ ! -f $LIB/libverify.so ]; then
	ln -snf $DESTAPPLIB/libverify/libverify.so $LIB/
fi
if [ ! -f $LIB/libverifyresult.so ]; then
	ln -snf $DESTAPPLIB/libverifyresult/libverifyresult.so $LIB/
fi
if [ ! -f $LIB/librecordquery.so ]; then
	ln -snf $DESTAPPLIB/librecordquery/librecordquery.so $LIB/
fi
if [ ! -f $LIB/libattstateinput.so ]; then
	ln -snf $DESTAPPLIB/libattstateinput/libattstateinput.so $LIB/
fi
if [ ! -f $LIB/libworkcode.so ]; then
	ln -snf $DESTAPPLIB/libworkcode/libworkcode.so $LIB/
fi
if [ ! -f $LIB/libsms.so ]; then
	ln -snf $DESTAPPLIB/libsms/libsms.so $LIB/
fi
if [ ! -f $LIB/liblawfulday.so ]; then
	ln -snf $DESTAPPLIB/liblawfulday/liblawfulday.so $LIB/
fi
if [ ! -f $LIB/libaccesscontrol.so ]; then
	ln -snf $DESTAPPLIB/libaccesscontrol/libaccesscontrol.so $LIB/
fi
if [ ! -f $LIB/libuseraccprivilege.so ]; then
	ln -snf $DESTAPPLIB/libuseraccprivilege/libuseraccprivilege.so $LIB/
fi
if [ ! -f $LIB/libprinter.so ]; then
	ln -snf $DESTAPPLIB/libprinter/libprinter.so $LIB/
fi
if [ ! -f $LIB/libwiegand.so ]; then
	ln -snf $DESTAPPLIB/libwiegand/libwiegand.so $LIB/
fi

if [ ! -f /lib/libzkweb.so ]; then
        ln -snf $LIB/libzkweb.so /lib/libzkweb.so
fi

#if [ -f $LIB/libzkwdt.so ]; then
#	mv $LIB/libzkwdt.so $LIB/libzkwdt.so.bak
#fi

Service=${LicdmService}
if [ -f $DESTSERVICE/${Service} ]; then
	echo "${Service} run"
	if [ "${LOGTEST}" = "yes" ]; then
		cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
	else
		cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
	fi
fi
echo "${Service} run over"

while [ ! -e /var/tmp/commskt.socket ]; do
	sync
	usleep 50000
done;

usleep 50000

#Service=${HubService}
Service=${HubService}
if [ -f $DESTSERVICE/${Service} ]; then
	echo "${Service} run"
	if [ "${LOGTEST}" = "yes" ]; then
		cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
	else
		cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
	fi
fi
echo "${Service} run over"

while [ ! -e /var/nfftmp/hub ]; do
	usleep 50000
done;

if [ -f $DESTSERVICE/${OptionsTool} ]; then
	if [ "${LOGTEST}" = "yes" ]; then
		cd $DESTSERVICE && chmod u+x $DESTSERVICE/${OptionsTool} && $DESTSERVICE/${OptionsTool} ${LOGLEVEL} > ${LOGDIR}/${OptionsTool}${LOGSUFFIX}
	else
		cd $DESTSERVICE && chmod u+x $DESTSERVICE/${OptionsTool} && $DESTSERVICE/${OptionsTool}
	fi
fi

Service=${DevService}
pgrep ${Service} > /dev/nul
if [ "$?" != 0 ]; then
	if [ -f $DESTSERVICE/${Service} ]; then
		echo "${Service} run"
		if [ "${LOGTEST}" = "yes" ]; then
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
		else
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
		fi
	fi

	while [ ! -e /var/nfftmp/dev ]; do
		usleep 50000
	done;
fi
echo "${Service} run over"

Service=${BiometricService}
pgrep ${Service} > /dev/nul
if [ "$?" != 0 ]; then
	if [ -f $DESTSERVICE/${Service} ]; then
		echo "${Service} run"
		if [ "${LOGTEST}" = "yes" ]; then
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
		else
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
		fi
	fi
fi
echo "${Service} run over"

usleep 50000

Service=${MginitService}
pgrep ${Service} > /dev/nul
if [ "$?" != 0 ]; then
	if [ -f $DESTAPP/mginit/${Service} ]; then
		echo "${Service} run"
		if [ "${LOGTEST}" = "yes" ]; then
			cd $DESTAPP/mginit && chmod u+x $DESTAPP/mginit/${Service} && $DESTAPP/mginit/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
		else
			cd $DESTAPP/mginit && chmod u+x $DESTAPP/mginit/${Service} && $DESTAPP/mginit/${Service} &
		fi
	fi
fi
echo "${Service} run over"

while [ ! -e /var/nfftmp/main ]; do
	usleep 50000
done;

usleep 50000 && usleep 50000
usleep 50000 && usleep 50000
usleep 50000 && usleep 50000
usleep 50000 && usleep 50000
usleep 50000 && usleep 50000
usleep 50000 && usleep 50000
usleep 50000

Service=${PushService}
pgrep ${Service} > /dev/nul
if [ "$?" != 0 ]; then
	if [ -f $DESTSERVICE/${Service} ]; then
		echo "${Service} run"
		if [ "${LOGTEST}" = "yes" ]; then
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${PUSHLOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
		else
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
		fi
	fi
fi
echo "${Service} run over"

usleep 50000

Service=${PullService}
pgrep ${Service} > /dev/nul
if [ "$?" != 0 ]; then
	if [ -f $DESTSERVICE/${Service} ]; then
		echo "${Service} run"
		if [ "${LOGTEST}" = "yes" ]; then
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
		else
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
		fi
	fi
fi
echo "${Service} run over"

usleep 50000

Service=${StandaloneService}
pgrep ${Service} > /dev/nul
if [ "$?" != 0 ]; then
	if [ -f $DESTSERVICE/${Service} ]; then
		echo "${Service} run"
		if [ "${LOGTEST}" = "yes" ]; then
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
		else
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
		fi
	fi
fi
echo "${Service} run over"

usleep 50000

Service=${WebService}
pgrep ${Service} > /dev/nul
if [ "$?" != 0 ]; then
	if [ -f $DESTSERVICE/${Service} ]; then
		echo "${Service} run"
		if [ "${LOGTEST}" = "yes" ]; then
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} ${LOGLEVEL} > ${LOGDIR}/${Service}${LOGSUFFIX} &
		else
			cd $DESTSERVICE && chmod u+x $DESTSERVICE/${Service} && $DESTSERVICE/${Service} &
		fi
	fi
fi
echo "${Service} run over"

if [ "${LOGTEST}" = "yes" ]; then
	while [ ! -s /var/tmp/minigui ]; do
		sleep 1
	done;
	
	pgrep ${MainApp} > /dev/nul
	if [ "$?" != 0 ]; then
		if [ -f $DESTAPP/main/${MainApp} ]; then
			echo "${MainApp} run"
			cd $DESTAPP/main && chmod u+x $DESTAPP/main/${MainApp} && $DESTAPP/main/${MainApp} ${LOGLEVEL} > ${LOGDIR}/${MainApp}${LOGSUFFIX} &
		fi
	fi
fi
echo "${MainApp} run over"

if [ -f $DESTAPP/main/${MainApp} ]; then
	cd $DESTAPP/main/${MainApp} && chmod u+x $DESTAPP/main/${MainApp} && $DESTAPP/main/${MainApp} -p 5 -t 3600 -m "$DEST/app/main/main"
fi

if [ -f $DEST/data/wdt ]; then
	cd $DEST/data && chmod u+x $DEST/data/wdt && $DEST/data/wdt -p 5 -t 3600 -m "$DEST/app/main/main"
fi

